//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "Thread.h"
#include "uart.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

char cPort,cData,cStop,cParity;
DWord dwBaudRate,RxMsgCnt=0;
bool IsCOMOpen=false;


//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
  IsCOMOpen=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ExitClick(TObject *Sender)
{
  if(IsCOMOpen)
  {
    IsCOMOpen=0;
    MyThread->Terminate();
    Sleep(500);
    Close_Com(cPort);
    Sleep(500);
  }
  Close();

}
//---------------------------------------------------------------------------


void __fastcall TForm1::Combo_COMPortChange(TObject *Sender)
{
  switch(Combo_COMPort->ItemIndex)
  {
        case 0:
            cPort = 1;
            break;
        case 1:
            cPort = 2;
            break;
        case 2:
            cPort = 3;
            break;
        case 3:
            cPort = 4;
            break;
        case 4:
            cPort = 5;
            break;
        case 5:
            cPort = 6;
            break;
        case 6:
            cPort = 7;
            break;
        case 7:
            cPort = 8;
            break;
        case 8:
            cPort = 9;
            break;
        default:
            cPort = 1;
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Combo_COMBaudChange(TObject *Sender)
{
  switch(Combo_COMBaud->ItemIndex)
  {
        case 0:
            dwBaudRate = 9600;
            break;
        case 1:
            dwBaudRate = 19200;
            break;
        case 2:
            dwBaudRate = 38400;
            break;
        case 3:
            dwBaudRate = 57600;
            break;
        case 4:
            dwBaudRate = 115200;
            break;
        case 5:
            dwBaudRate = 230400;
            break;
        case 6:
            dwBaudRate = 460800;
            break;
        case 7:
            dwBaudRate = 921600;
            break;
        default:
            dwBaudRate = 921600;

  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Combo_COMDataChange(TObject *Sender)
{
  switch(Combo_COMData->ItemIndex)
  {
        case 0:
            cData = 5;
            break;
        case 1:
            cData = 6;
            break;
        case 2:
            cData = 7;
            break;
        case 3:
            cData = 8;
            break;
        default:
            cData = 8;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Combo_COMParityChange(TObject *Sender)
{
  switch(Combo_COMParity->ItemIndex)
  {
        case 0:
            cParity = 0;  //None
            break;
        case 1:
            cParity = 1;  //Odd
            break;
        case 2:
            cParity = 2;  //Even
            break;
        default:
            cParity = 0;
  }        
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Combo_COMStopChange(TObject *Sender)
{
  switch(Combo_COMStop->ItemIndex)
  {
        case 0:
            cStop = 0;  //1
            break;
        case 1:
            cStop = 1;  //1.5
            break;
        case 2:
            cStop = 2;  //2
            break;
        default:
            cStop = 0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
  Combo_COMPort->ItemIndex=0;
  Combo_COMBaud->ItemIndex=4;
  Combo_COMData->ItemIndex=3;
  Combo_COMParity->ItemIndex=0;
  Combo_COMStop->ItemIndex=0;
  cPort=1;
  dwBaudRate=115200;
  cData=8;
  cParity=0;
  cStop=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_OpenCOMClick(TObject *Sender)
{
  DWord dwErrNo;
  
  dwErrNo=Open_Com(cPort,dwBaudRate,cData,cParity,cStop);
  if(dwErrNo==0)
  {
    IsCOMOpen = true;
    Button_OpenCOM->Enabled=false;
    Button_CloseCOM->Enabled=true;
    Combo_COMPort->Enabled=false;
    Combo_COMBaud->Enabled=false;
    Combo_COMData->Enabled=false;
    Combo_COMParity->Enabled=false;
    Combo_COMStop->Enabled=false;
    Button_Send->Enabled=true;

    MyThread=new TMyThread();
  }
  else
  {
    IsCOMOpen = false;
    Button_OpenCOM->Enabled=true;
    Button_CloseCOM->Enabled=false;
    Button_Send->Enabled=false;

    AnsiString ErrStr;
    ErrStr.printf("Open COM Error, Error Code %lu",dwErrNo);
    ShowMessage(ErrStr);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_CloseCOMClick(TObject *Sender)
{
  if(IsCOMOpen)
  {
    MyThread->Terminate();
    Close_Com(cPort);
    Button_OpenCOM->Enabled=true;
    Button_CloseCOM->Enabled=false;
    
    Combo_COMPort->Enabled=true;
    Combo_COMBaud->Enabled=true;
    Combo_COMData->Enabled=true;
    Combo_COMParity->Enabled=true;
    Combo_COMStop->Enabled=true;
    IsCOMOpen=false;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_ClearClick(TObject *Sender)
{
  if(Form1->ListView1->Tag == 1)
  {
    ListView1->Items->Clear();
    RxMsgCnt=0;
  }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button_SendClick(TObject *Sender)
{
  AnsiString send;
  int NumCheck,DLC;

  if(Edit_MsgID->Text=="")  Edit_MsgID->Text="000";
  NumCheck= StrToInt("0x"+Edit_MsgID->Text);
  if (CANCheckBox->Checked)
  {
      if(Edit_MODE->Text=="")   Edit_MODE->Text="0";
      if(Edit_RTR->Text=="")  Edit_RTR->Text="0";
      
      if(Edit_MODE->Text=="0")
      {
          if(Edit_RTR->Text=="0")
            send='t';
          else
            send='T';
          if(NumCheck>0x7FF)  NumCheck=0x7FF;
          send=send+IntToHex(NumCheck, 3);
      }
      else
      {
          if(Edit_RTR->Text=="0")
            send='e';
          else
            send='E';

          if(NumCheck>0x1FFFFFFF)  NumCheck=0x1FFFFFFF;
          send=send+IntToHex(NumCheck, 8);
      }

      if(Edit_DLC->Text=="")    Edit_DLC->Text="0";
      if(StrToInt(Edit_DLC->Text)>8)    Edit_DLC->Text="0";
      send=send+Edit_DLC->Text;
      
      if(Edit_RTR->Text=="0")
      {
          if(Edit_DLC->Text=="")  Edit_DLC->Text="0";
          DLC=StrToInt(Edit_DLC->Text);
          if (DLC>0)
          {
            if(Edit_D0->Text=="") Edit_D0->Text="00";
            NumCheck= StrToInt("0x"+Edit_D0->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>1)
          {
            if(Edit_D1->Text=="") Edit_D1->Text="00";
            NumCheck= StrToInt("0x"+Edit_D1->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>2)
          {
            if(Edit_D2->Text=="") Edit_D2->Text="00";
            NumCheck= StrToInt("0x"+Edit_D2->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>3)
          {
            if(Edit_D3->Text=="") Edit_D3->Text="00";
            NumCheck= StrToInt("0x"+Edit_D3->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>4)
          {
            if(Edit_D4->Text=="") Edit_D4->Text="00";
            NumCheck= StrToInt("0x"+Edit_D4->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>5)
          {
            if(Edit_D5->Text=="") Edit_D5->Text="00";
            NumCheck= StrToInt("0x"+Edit_D5->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>6)
          {
            if(Edit_D6->Text=="") Edit_D6->Text="00";
            NumCheck= StrToInt("0x"+Edit_D6->Text);
            send=send+IntToHex(NumCheck, 2);
          }
          if (DLC>7)
          {
            if(Edit_D7->Text=="") Edit_D7->Text="00";
            NumCheck= StrToInt("0x"+Edit_D7->Text);
            send=send+IntToHex(NumCheck, 2);
          }
      }
      SendEdit->Text=send;
      Send_Cmd(cPort,send.c_str(),1);
  }
  else
  {
    send=SendEdit->Text;
    Send_Cmd(cPort,send.c_str(),0);
  }

}
//---------------------------------------------------------------------------

void __fastcall TForm1::Edit_MODEChange(TObject *Sender)
{
  if(Edit_MODE->Text=="0") Edit_MsgID->MaxLength=3;
  else  Edit_MsgID->MaxLength=8;
}
//---------------------------------------------------------------------------


_fastcall TMyThread::TMyThread(void):TThread(true)
{
  FreeOnTerminate=true;
  Resume();
}

void __fastcall TMyThread::Execute()//Thread function
{
  AnsiString receive,Str;
  char *c;
  DWord RxdataNum;
  Word ret,wT,wTimeOut=10,wChksum=0;

  TListItem *ListItem;
  bool IsCorrectMsg=false;
  unsigned char Data[8];
  unsigned short Mode,RTR,DataLen,i;
  DWord MsgID;


  receive.SetLength(100);

  while(!Terminated)
  {
    if(IsCOMOpen)
    {
      RxdataNum=DataSizeInCom(cPort);
      if(RxdataNum > 0)
      {
        ret=Receive_Cmd(cPort,receive.c_str(),wTimeOut,wChksum,&wT);
        if(!ret)
        {
          /*
          Form1->ReceiveListBox->Items->Add(receive);
          Form1->ReceiveListBox->TopIndex= Form1->ReceiveListBox->Items->Count-1;
          if(Form1->ReceiveListBox->Items->Count>1000)
          {
            Form1->ReceiveListBox->Items->Clear();
          }
          */

          c=receive.c_str();
          switch(c[0])
          {
            case 't':
                Mode=0;
                MsgID=StrToInt("0x"+receive.SubString(2,3));
                RTR=0;
                DataLen=StrToInt(receive.SubString(5,1));
                for(i=0;i<DataLen;i++)
                {
                  Data[i]=StrToInt("0x"+receive.SubString(6+i*2,2));
                }
                IsCorrectMsg=true;
              break;
            case 'T':
                Mode=0;
                MsgID=StrToInt("0x"+receive.SubString(2,3));
                RTR=1;
                DataLen=StrToInt(receive.SubString(5,1));
                IsCorrectMsg=true;
              break;
            case 'e':
                Mode=1;
                MsgID=StrToInt("0x"+receive.SubString(2,8));
                RTR=0;
                DataLen=StrToInt("0x"+receive.SubString(10,1));
                for(i=0;i<DataLen;i++)
                {
                  Data[i]=StrToInt("0x"+receive.SubString(11+i*2,2));
                }
                IsCorrectMsg=true;
              break;
            case 'E':
                Mode=1;
                MsgID=StrToInt("0x"+receive.SubString(2,8));
                RTR=0;
                DataLen=StrToInt("0x"+receive.SubString(10,1));
                IsCorrectMsg=true;
              break;
            default:
                IsCorrectMsg=false;
              break;
          }

          if(IsCorrectMsg)
          {
            Form1->ListView1->Tag = 0; //Disable Change Event
            ListItem = Form1->ListView1->Items->Add();

            Str.printf("%d",RxMsgCnt);
            ListItem->Caption = Str; //Handle No

            Str.printf("%s",Mode?"29-Bit":"11-Bit");
            ListItem->SubItems->Add(Str);  //Mode

            Str.printf("%lX",MsgID);
            ListItem->SubItems->Add(Str); //MsgID

            Str.printf("%c",RTR?'Y':'N');
            ListItem->SubItems->Add(Str); //RTR

            Str.printf("%d",DataLen);
            ListItem->SubItems->Add(Str); //DataLen

            for(i=0;i<8;i++)
            {
              if((i < DataLen) && (RTR == 0))
                Str.printf("%02X",Data[i]);
              else
                Str = " ";
              ListItem->SubItems->Add(Str);
            }

            RxMsgCnt++;
            Form1->ListView1->Tag = 1;
            Form1->ListView1->Perform(LVM_SCROLL,0,10);

            if(Form1->ListView1->Items->Count>500)
            {
              Form1->ListView1->Items->Clear();
              RxMsgCnt=0;
            }
          }
        }
      }
    }
    Application->ProcessMessages() ;
    Sleep(1);
  }
}

//---------------------------------------------------------------------------


